//UG-2864HSWEG01(OLED){SSD1306(Rg[)
//I2C, ChargePump, 128x64dot
//	wt]xH쎺	http://jsdiy.web.fc2.com
/*
I2CʐM
`揈
t[obt@
tHg
*/

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include "twilib.h"
#include "SSD1306i2c.h"
#include "Font5x7.h"

//foCX̃X[uAhX(6bit+1bit + r/w)
#define SSD1306I2C_SLAVE_ADDRESS	(0b011110 << 2)
#define SLA_W_BIT	0
#define SLA_R_BIT	1
static	uint8_t	SlaveAddressW;

static	uint8_t WriteStartSequence(uint8_t ctrlByte)
{
	return
		TWI_Start() &&
		TWI_SlaveAddrW(SlaveAddressW) &&
		TWI_WriteByte(ctrlByte);
}

#define	CTRLBYTE_COMMAND	0x00	//Co=0, D/C#=0(Command)
#define	CTRLBYTE_DATA		0x40	//Co=0, D/C#=1(Data)

static	uint8_t	SendCommand(uint8_t cmd)
{
	uint8_t isOK = WriteStartSequence(CTRLBYTE_COMMAND) &&
		TWI_WriteByte(cmd);
	TWI_Stop();
	return isOK;
}

static	uint8_t SendCommandP1(uint8_t cmd, uint8_t p1)
{
	uint8_t isOK = WriteStartSequence(CTRLBYTE_COMMAND) &&
		TWI_WriteByte(cmd) &&
		TWI_WriteByte(p1);
	TWI_Stop();
	return isOK;
}

static	uint8_t SendCommandP2(uint8_t cmd, uint8_t p1, uint8_t p2)
{
	uint8_t isOK = WriteStartSequence(CTRLBYTE_COMMAND) &&
		TWI_WriteByte(cmd) &&
		TWI_WriteByte(p1) &&
		TWI_WriteByte(p2);
	TWI_Stop();
	return isOK;
}

static	void	Reset()
{
	/*	SSD1306 datasheet	8.5 Reset Circuit
	When RES# input is LOW, the chip is initialized with the following status:
	1. Display is OFF
	2. 128 x 64 Display Mode
	3. Normal segment and display data column address and row address mapping (SEG0 mapped to address 00h and COM0 mapped to address 00h)
	4. Shift register data clear in serial interface
	5. Display start line is set at display RAM address 0
	6. Column address counter is set at 0
	7. Normal scan direction of the COM outputs
	8. Contrast control register is set at 7Fh
	9. Normal display mode (Equivalent to A4h command)
	*/
	SSD1306I2C_RESET_DDR |= SSD1306I2C_RESET_BIT;	//o͕ɃZbg
	SSD1306I2C_RESET_PORT &= ~SSD1306I2C_RESET_BIT;	//LoiZbgEIj
	_delay_ms(1);	//3usȏ
	SSD1306I2C_RESET_PORT |= SSD1306I2C_RESET_BIT;	//HiiZbgj
}

//iN1sΏ\j
void	SSD1306I2C_Init(uint8_t bitSA0)
{
	SlaveAddressW = SSD1306I2C_SLAVE_ADDRESS | (bitSA0 << 1) | SLA_W_BIT;

	Reset();

	//ER}hsƓeUG-2864HSWEG0f[^V[gB
	//EZbgɃZbglƓl̂̂̓RgAEgB
	//SendCommand(0xAE);	//Set Display OFF
	//SendCommandP1(0xD5, 0x80);	//Set Display Clock Divide Ratio/Oscillator Frequency
	//SendCommandP1(0xA8, 0x3F);	//Set Multiplex Ratio
	//SendCommandP1(0xD3, 0x00);	//Set Display Offset
	//SendCommand(0x40);	//Set Display Start Line
	SendCommandP1(0x8D, 0x14);	//Charge Pump Setting
	SendCommand(0xA1);	//Set Segment Re-map			]	}2̃R}hŁA
	SendCommand(0xC8);	//Set COM Output Scan Direction	]	}ʂ180x]邱ƂɂȂB
	//SendCommandP1(0xDA, 0x12);	//Set COM Pins Hardware Configuration
	//SendCommandP1(0x81, 0x7F);	//Set Contrast Control	PxBD݂ŕύX
	//SendCommandP1(0xD9, 0x22);	//Set Pre-charge Period	OLED̉f`[W	iSSD1306f[^V[gu8.6 Segment Drivers / Common DriversvQƁjiUG-2864HSWEG0f[^V[gł̓`[W|v0xF1IXX̖͗lj
	//SendCommandP1(0xDB, 0x20);	//Set VCOMH Deselect Level	f[^V[ǵu0x40v͊ԈႢ
	//SendCommand(0xA4);	//Entire Display ON	(0xA4:GDDRAM̓e𕜌, 0xA5:Sf'ON'(1)ɂ; RESETl0xA4)
	//SendCommand(0xA6);	//Set Normal/Inverse Display (0xA6:Normal, 0xA7:Inverse; RESETl0xA6)
	
	/*	GDDRAM̃AhX[hw肷
		00b, Horizontal Addressing Mode		//ړA玟̍s̐擪ֈړ
		01b, Vertical Addressing Mode		//ړA玟̗̐擪ֈړ
		10b, Page Addressing Mode (RESET)	//ړA獡̍s̐擪֖߂
		11b, Invalid
	*/
	SendCommandP1(0x20, 0b00);	//Set Memory Addressing Mode

	ColorModeNormal();
	GR_Cls();	//ʂ
	FB_Cls();	//t[obt@
	
	SendCommand(0xAF);	//Set Display ON
}

//yGDDRAM̕`Pʂ\pz
//XuZOgvAYuy[WvBZOg̕1JAy[W̍8JB
#define DotToSegment(n)	(n)
#define DotToPage(n)	((n) / 8)

//ʂZOgAy[WPʂŕ\l
#define ScreenSizeXS	DotToSegment(ScreenSizeWD)
#define ScreenSizeYP	DotToPage(ScreenSizeHD)

//f[^]̋`̈iGDDRAM̃AhXjw肷
static	uint8_t	GR_SetRectangle(uint8_t x_segment, uint8_t y_page, uint8_t w_segment, uint8_t h_page)
{
	return	SendCommandP2(0x21, x_segment, x_segment + w_segment - 1)	//Set Column AddressiZOgj
		&&	SendCommandP2(0x22, y_page, y_page + h_page - 1);			//Set Page Addressiy[Wj
}

//`F
//1: OiF͓_FAwiF͏F	cʏ̕`F
//0: OiF͏FAwiF͓_F	c]
static	uint8_t colorBit;

//`FZbg
void	ColorModeNormal() { colorBit = 1; }
void	ColorModeInverse() { colorBit = 0; }	//][h

//`̈hԂ
//:	JnʒuƑ傫BZOgCy[WPʁB
void	GR_FillRect(uint8_t x_segment, uint8_t y_page, uint8_t w_segment, uint8_t h_page)
{
	uint8_t	x, y;
	uint8_t	color = (colorBit == 1) ? 0xFF : 0x00;

	if (!GR_SetRectangle(x_segment, y_page, w_segment, h_page)) return;
	
	if (!WriteStartSequence(CTRLBYTE_DATA)) goto FINISH;
	for (y = 0; y < h_page; y++)
		for (x = 0; x < w_segment; x++)
			if (!TWI_WriteByte(color)) goto FINISH;
FINISH:
	TWI_Stop();
}

//`̈i݂̔wiFœhԂj
//:	JnʒuƑ傫BZOgCy[WPʁB
void	GR_ClearRect(uint8_t x_segment, uint8_t y_page, uint8_t w_segment, uint8_t h_page)
{
	colorBit = 1 - colorBit;	//OiFƔwiFւ
	GR_FillRect(x_segment, y_page, w_segment, h_page);
	colorBit = 1 - colorBit;	//OiFƔwiFւiɖ߂j
}

//ʂ݂̔wiFœhԂ
void	GR_Cls()
{
	GR_ClearRect(0, 0, ScreenSizeXS, ScreenSizeYP);
}

//iR[hjɑΉtHgf[^擾
//EtHg`̃f[^̓vÖɊi[Ă̂ƂB
//	̂Ŗ߂ĺAYf[^̃vÖ̃AhXԂB
//E߂l󂯎֐pgm_read_byte()čŏIIȕf[^擾B
static	const uint8_t*	GetFontDataP(char cc)
{
	uint8_t	cidx = (uint8_t)cc;

	if (0x20 <= cidx && cidx <= 0x7F) return FONT_5x7[cidx - 0x20];
	if (0xA1 <= cidx && cidx <= 0xDF) return FONT_5x7_KANA[cidx - 0xA1];
	return FONT_5x7[0];		//Yf[^Ȃꍇ̓Xy[X(0x20)Ԃ
}

//`
//:	JnʒuBZOgCy[WPʁB
void	GR_DrawChar(uint8_t x_segment, uint8_t y_page, char cc)
{
	uint8_t	i, fontBits;
	const uint8_t*	fontData = GetFontDataP(cc);
	
	if (!GR_SetRectangle(x_segment, y_page, ScreenSizeXS - x_segment, ScreenSizeYP - y_page)) return;

	if (!WriteStartSequence(CTRLBYTE_DATA)) goto FINISH;
	for (i = 0; i < FontW; i++)
	{
		fontBits = (i < FontBitDataX) ? pgm_read_byte(&fontData[i]) : 0x00;	//0x00͕Ԃ̕
		if (colorBit == 0) fontBits = ~fontBits;	//]̏ꍇ
		if (!TWI_WriteByte(fontBits)) goto FINISH;
	}
FINISH:
	TWI_Stop();
}

//`
//	x,y:	JnʒuBZOgCy[WPʁB
//		sp:	vÖɊi[ꂽ
//߂l:	`
uint8_t	GR_DrawString(uint8_t x_segment, uint8_t y_page, const char* sp)
{
	uint8_t count, cc;

	for (count = 0; x_segment + FontBitDataX <= ScreenSizeXS; count++, x_segment += FontW)
	{
		cc = pgm_read_byte(sp++);
		if (cc == '\0') break;
		GR_DrawChar(x_segment, y_page, cc);
	}
	return count;
}

//`	MultiLine
/*	ppxႭAeʂĤŃRgAEg
void	GR_DrawStringML(uint8_t x_segment, uint8_t y_page, const char* sp, uint8_t maxLine)
{
	uint8_t charCount, offset, lineCount;
	uint8_t page;

	for (lineCount = 0, offset = 0; lineCount < maxLine; lineCount++, offset += charCount)
	{
		page = y_page + lineCount;
		if (ScreenSizeYP <= page) break;	//ŉs`̈͂ݏo悤Ȃ`Ȃ
		charCount = GR_DrawString(x_segment, page, &sp[offset]);
		if (charCount == 0) break;
	}
}
*/

//t[obt@̈ʒu^TCY̒`
#define FBSizeXS	DotToSegment(FBSizeWD)	//ZOgiJjP
#define FBSizeYP	DotToPage(FBSizeHD)		//y[WP

#define FB_StartSegment	DotToSegment(FB_ScreenLeft)
#define FB_StartPage	DotToPage(FB_ScreenTop)

//t[obt@
//EGDDRAMƓc̓y[WPʂŒlB
//E1hbg=1rbgB1y[W͏c8hbgi1oCgjōŉ[MSBAŏ[LSBB
static	uint8_t frameBuf[FBSizeYP][FBSizeXS];

//y`֐ƃt[obt@Ǝ(GDDRAM)̊֌Wz
//t[obt@ւ̕`֐ FB_Xxx() --> [t[obt@] FB_Update() --> []
//ʂւ̕`֐           GR_Xxx() -------------------------------------> []

//t[obt@̓eʂɓ]iʕ\XVj
void	FB_Update()
{
	uint8_t x, y;

	if (!GR_SetRectangle(FB_StartSegment, FB_StartPage, FBSizeXS, FBSizeYP)) goto FINISH;
	
	if (!WriteStartSequence(CTRLBYTE_DATA)) goto FINISH;
	for (y = 0; y < FBSizeYP; y++)
		for (x = 0; x < FBSizeXS; x++)
			if (!TWI_WriteByte(frameBuf[y][x])) goto FINISH;
FINISH:
	TWI_Stop();
}

//t[obt@݂̔wiFœhԂ
void	FB_Cls()
{
	FB_ClearRect(0, 0, FBSizeWD, FBSizeHD);
}

//_ł^
//:	t[obt@̍(0,0)ƂA1hbgPʂ̍W(x,y)
//		bit = 1:_ł, 0:_
static	void	FB_SetBit(uint8_t x, uint8_t y, uint8_t bit)
{
	uint8_t segmentX = x;	//ZOg
	uint8_t pageY = y / 8, columnY = y % 8;	//y[WAy[W̃J
	
	if (FBSizeXS <= segmentX || FBSizeYP <= pageY) return;

	if (bit)
		frameBuf[pageY][segmentX] |= (1 << columnY);	//1Zbg
	else
		frameBuf[pageY][segmentX] &= ~(1 << columnY);	//0Zbg
}

//_`
void	FB_DrawPixel(uint8_t x, uint8_t y)
{
	FB_SetBit(x, y, colorBit);
}

//`
//:	n_W(x1,y1)AI_W(x2,y2)
void	FB_DrawLine(uint8_t x1, uint8_t y1, uint8_t x2, uint8_t y2)
{
	uint8_t	tmp, x, y;
	uint8_t	lengthX, lengthY;
	int8_t step;
	float	e, esum, esumPrev;	//CvV

	lengthX = (x1 < x2) ? (x2 - x1) : (x1 - x2);
	lengthY = (y1 < y2) ? (y2 - y1) : (y1 - y2);
	//Ă邱Ƃabs()

	//iun_=I_v͂ňj
	if (lengthY == 0)
	{
		for (x = x1; x <= x2; x++) FB_DrawPixel(x, y1);
		return;
	}
	
	//
	if (lengthX == 0)
	{
		for (y = y1; y <= y2; y++) FB_DrawPixel(x1, y);
		return;
	}

	//c^ɂď𕪂
	if (lengthX < lengthY)
	{
		//c
		if (y2 < y1) { tmp = x2; x2 = x1; x1 = tmp;	tmp = y2; y2 = y1; y1 = tmp; }	//㑤̓_n_ɂ
		step = (x1 < x2) ? 1 : -1;	//ړ̈ړʁFE=1, =-1
		e = (float)lengthX / (float)lengthY;	//c1hbgړ̉ւ̈ړ
		esum = 0.0f;
		for (x = x1, y = y1; y < y2; y++)
		{
			FB_DrawPixel(x, y);
			esumPrev = esum;
			esum += e;
			if ((uint8_t)esumPrev < (uint8_t)esum) x += step;
		}
		FB_DrawPixel(x2, y2);
	}
	else
	{
		//
		if (x2 < x1) { tmp = x2; x2 = x1; x1 = tmp;	tmp = y2; y2 = y1; y1 = tmp; }	//̓_n_ɂ
		step = (y1 < y2) ? 1 : -1;	//cړ̈ړʁFE=1, Eオ=-1
		e = (float)lengthY / (float)lengthX;	//1hbgړ̏cւ̈ړ
		esum = 0.0f;
		for (x = x1, y = y1; x < x2; x++)
		{
			FB_DrawPixel(x, y);
			esumPrev = esum;
			esum += e;
			if ((uint8_t)esumPrev < (uint8_t)esum) y += step;
		}
		FB_DrawPixel(x2, y2);
	}

	/*	y`̕@z
	Ew肳ꂽΊpƂ`̏cāAZӂ𒷕ӂŊāAړ߂B
		ł͕֋XIɃCvVƌĂԂƂɂB
	Eӂ1hbgړȂZӕ̃CvVݐςB
	@CvV̏JオƂi1ƂjɒZӂ1hbgړB
		ǂ͏؂̂ĂĔrB
		@0ւ̊ۂߍ݁Bfloor()֐iւ̊ۂߍ݁jł͂ȂB
		@܂Pint^ɃLXg΂悢B
	Eݐς̓Zbgɗݐς邱ƂŁAZӈړ̌덷zB
	EŌ_̎O܂ŌvZœ_łAŌ_͈Ŏw肳ꂽI_łBvZ̍ŏI_͑łȂB
		lݐςĂsAŌ̓_{̏I_ƈvȂƂ邽
		@iMMŐ֌JオȂjAmɏI_ɑł悤ɂB
	*/
}

//`̈hԂ
//:	`̍W(x,y)A`̕ƍ
void	FB_FillRect(uint8_t x, uint8_t y, uint8_t w, uint8_t h)
{
	uint8_t ix, iy;
	for (iy = y; iy < y + h; iy++)
		for (ix = x; ix < x + w; ix++)
			FB_DrawPixel(ix, iy);
}

//`̈i݂̔wiFœhԂj
//:	`̍W(x,y)A`̕ƍ
void	FB_ClearRect(uint8_t x, uint8_t y, uint8_t w, uint8_t h)
{
	colorBit = 1 - colorBit;	//OiFƔwiFւ
	FB_FillRect(x, y, w, h);
	colorBit = 1 - colorBit;	//OiFƔwiFւiɖ߂j
}

//`
//:	JnʒuB1hbgPʁB
void	FB_DrawChar(uint8_t x, uint8_t y, char cc)
{
	uint8_t	ix, iy, fontBits, bit;
	const uint8_t*	fontData = GetFontDataP(cc);

	for (ix = 0; ix < FontW; ix++)
	{
		fontBits = (ix < FontBitDataX) ? pgm_read_byte(&fontData[ix]) : 0x00;	//0x00͕Ԃ̕
		for (iy = 0; iy < FontH; iy++)
		{
			bit = (fontBits >> iy) & 0x01;
			if (colorBit == 0) bit = 1 - bit;	//]̏ꍇ
			FB_SetBit(x + ix, y + iy, bit);
		}
	}
}

//`
//	x,y:	JnʒuB1hbgPʁB
//		sp:	vÖɊi[ꂽ
//߂l:	`
uint8_t	FB_DrawString(uint8_t x, uint8_t y, const char* sp)
{
	uint8_t count, cc;

	for (count = 0; x + FontBitDataX <= FBSizeWD; count++, x += FontW)
	{
		cc = pgm_read_byte(sp++);
		if (cc == '\0') break;
		FB_DrawChar(x, y, cc);
	}
	return count;
}

//`	MultiLine
/*	ppxႭAeʂĤŃRgAEg
void	FB_DrawStringML(uint8_t x, uint8_t y, const char* sp, uint8_t maxLine)
{
	uint8_t charCount, offset, lineCount;
	uint8_t posY;

	for (lineCount = 0, offset = 0; lineCount < maxLine; lineCount++, offset += charCount)
	{
		posY = y + lineCount * FontH;
		if (FBSizeHD < posY + FontBitDataY) break;	//ŉs`̈͂ݏo悤Ȃ`Ȃ
		charCount = FB_DrawString(x, posY, &sp[offset]);
		if (charCount == 0) break;
	}
}
*/
